// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace Veneris.Communications
{

using global::System;
using global::System.Collections.Generic;
using global::FlatBuffers;

public struct RegisterGain : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_2_0_0(); }
  public static RegisterGain GetRootAsRegisterGain(ByteBuffer _bb) { return GetRootAsRegisterGain(_bb, new RegisterGain()); }
  public static RegisterGain GetRootAsRegisterGain(ByteBuffer _bb, RegisterGain obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public RegisterGain __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public sbyte Path(int j) { int o = __p.__offset(4); return o != 0 ? __p.bb.GetSbyte(__p.__vector(o) + j * 1) : (sbyte)0; }
  public int PathLength { get { int o = __p.__offset(4); return o != 0 ? __p.__vector_len(o) : 0; } }
#if ENABLE_SPAN_T
  public Span<sbyte> GetPathBytes() { return __p.__vector_as_span<sbyte>(4, 1); }
#else
  public ArraySegment<byte>? GetPathBytes() { return __p.__vector_as_arraysegment(4); }
#endif
  public sbyte[] GetPathArray() { return __p.__vector_as_array<sbyte>(4); }

  public static Offset<Veneris.Communications.RegisterGain> CreateRegisterGain(FlatBufferBuilder builder,
      VectorOffset pathOffset = default(VectorOffset)) {
    builder.StartTable(1);
    RegisterGain.AddPath(builder, pathOffset);
    return RegisterGain.EndRegisterGain(builder);
  }

  public static void StartRegisterGain(FlatBufferBuilder builder) { builder.StartTable(1); }
  public static void AddPath(FlatBufferBuilder builder, VectorOffset pathOffset) { builder.AddOffset(0, pathOffset.Value, 0); }
  public static VectorOffset CreatePathVector(FlatBufferBuilder builder, sbyte[] data) { builder.StartVector(1, data.Length, 1); for (int i = data.Length - 1; i >= 0; i--) builder.AddSbyte(data[i]); return builder.EndVector(); }
  public static VectorOffset CreatePathVectorBlock(FlatBufferBuilder builder, sbyte[] data) { builder.StartVector(1, data.Length, 1); builder.Add(data); return builder.EndVector(); }
  public static void StartPathVector(FlatBufferBuilder builder, int numElems) { builder.StartVector(1, numElems, 1); }
  public static Offset<Veneris.Communications.RegisterGain> EndRegisterGain(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<Veneris.Communications.RegisterGain>(o);
  }
  public static void FinishRegisterGainBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.RegisterGain> offset) { builder.Finish(offset.Value); }
  public static void FinishSizePrefixedRegisterGainBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.RegisterGain> offset) { builder.FinishSizePrefixed(offset.Value); }
};


}
